<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: src/standard/GraphGen/tiglGraphGenChangeGraph.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_1cf3643344231f8e6485fa845aa22d81.html">GraphGen</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglGraphGenChangeGraph.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglGraphGenChangeGraph_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#ifndef CHANGE_GRAPH_HPP_</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define CHANGE_GRAPH_HPP_</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> CVertex, <span class="keyword">typename</span> CWeightedVertex&gt;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keywordtype">void</span> Convert2Weighted(vector&lt;CVertex&gt; &amp; inList, vector&lt;CWeightedVertex&gt; &amp; outList, </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;                        <span class="keyword">typename</span> CWeightedVertex::EDGE_TYPE::DATA_TYPE minVal = 1, </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;                        <span class="keyword">typename</span> CWeightedVertex::EDGE_TYPE::DATA_TYPE maxVal = 1)</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> CWeightedVertex::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> CWeightedVertex::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> EDGE_TYPE::DATA_TYPE DATA_TYPE;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    outList.clear();</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">for</span>(<span class="keyword">typename</span> vector&lt;CVertex&gt;::iterator inIt= inList.begin();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            inIt != inList.end(); ++inIt)</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        CWeightedVertex newVertex(inIt-&gt;getId());</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">for</span>(<span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR ite = inIt-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                        ite != inIt-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        { <span class="comment">/*loop for chaning the edge value*/</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            <span class="comment">/*getting the edge value*/</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <span class="keywordtype">double</span> randVal;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            gen_urandom(&amp;randVal, 1);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            DATA_TYPE newVal = (DATA_TYPE)(randVal*(maxVal-minVal)+minVal);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            EDGE_TYPE newEdge(ite-&gt;getNbr(), newVal);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            <span class="comment">/*adding the adjusted edge to the vertex*/</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            newVertex.add_edge(newEdge);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        }</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="comment">/*adding the vertex to the output list*/</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        outList.push_back(newVertex);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="comment">/*now clearing the input*/</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    inList.clear();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="comment">/*filling the inEdge buffer if the vertex is bi_vertex*/</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordflow">if</span>(outList[0].is_bivertex() == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">for</span>(<span class="keyword">typename</span> vector&lt;CWeightedVertex&gt;::iterator itv= outList.begin();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;                itv != outList.end(); ++itv)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        {</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            ID_TYPE srcID = itv-&gt;getId();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <span class="keywordflow">for</span>(<span class="keyword">typename</span> CWeightedVertex::OUT_EDGE_ITERATOR ite = itv-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;                            ite != itv-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            {<span class="comment">/*loop over all output edges to write the corresponding iterator to the input edge list of the targets*/</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;                ID_TYPE target = ite-&gt;getNbr();</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                outList[target].add_in_edge(srcID);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            } <span class="comment">/*end of local edge iteration*/</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        }<span class="comment">/*end of vertices iteration*/</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    }<span class="comment">/*end of if condition*/</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;}</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
